#include "spawn.h"
#include <stdlib.h>
#include <fstream.h>

#include "..\algorithms.h"

///////// Prizes  ////////
void botInfo::Prize(Player *p)
{
	String response;
	response = "*prize";
	response+= prize;
	sendPrivate(p,response);

	ofstream prizefile("prizes.txt", ios::trunc);
	prizefile << the_whole_file_string;
	prizefile.close();
}


void botInfo::gotHelp(Player *p, Command *c)
{
	// List commands

	if (!*c->final)
	{
		switch (p->access)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_SysOp:
			{	// SysOp-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
//				sendPrivate(p, "Ext: ");
			}
				sendPrivate(p, "Prize: !prize !addprize !listprize !allowclaim !prizemode !endprize ");
		case OP_Moderator:
			{	// Moderator-level commands
				sendPrivate(p, "Prize: !prize !listprize !allowclaim !prizemode !endprize ");
			}
			break;
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
				sendPrivate(p, "!about !prizeme !listprize");
			}
		}

		return;
	}

	// Specific command help

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
			if (c->checkParam("owner") || c->checkParam("all"))
			{
//				sendPrivate(p, "Ext: ");
			}
		}
	case OP_SysOp:
		{	// SysOp-level commands
			if (c->checkParam("sop") || c->checkParam("all"))
			{
//				sendPrivate(p, "Ext: ");
			}
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			if (c->checkParam("smod") || c->checkParam("all"))
			{
			}
			if (c->checkParam("addprize"))
				sendPrivate(p,"!addprize [name]:[item/amount]  adds person to prize storage list for prize #[prize] or for a certaion ammount of bounty");
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if (c->checkParam("mod") || c->checkParam("all"))
			{
//				sendPrivate(p, "Ext: ");
			}
			if (c->checkParam("endprize"))
				sendPrivate(p,"!endprize [#]   sets the amount of bounty that is prized at the end of a flaggame.  0 disables");
			if (c->checkParam("prize"))
				sendPrivate(p,"!prize [#]  Announces and waits 10 seconds to prize everyone [#] bounty.");
			if (c->checkParam("prizemode"))
				sendPrivate(p,"!prizemode [soccer/flag/off]   Toggles whether to prize at end of flag game or soccer goal.");
			if (c->checkParam("listprize"))
				sendPrivate(p,"!listprize [player]   Shows all prizes available to player.");
			if (c->checkParam("allowclaim"))
				sendPrivate(p,"!allowclaim [true/false]   Disables !prizeme.  Useful for event subarenas");

		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
			if (c->checkParam("about"))
				sendPrivate(p, "!about (query me about my function)");
			if (c->checkParam("prizeme"))
				sendPrivate(p,"!prizeme  Prize yourself oldest available prize.");
			if (c->checkParam("listprize"))
				sendPrivate(p,"!listprize  List available prizes.");
		}
	}
}

void botInfo::gotCommand(Player *p, Command *c)
{
	if (!p) return;
	if (!c) return;

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			if (c->check("version"))
			{
				sendPrivate(p, "[name:prize.dll] [maker:Explody Thingy (explody@sscentral.com)] [build:2]");
			}
			if (c->check("addprize"))
			{
				String prize = c->final;
				String name = prize.split(':');
				String response;
				response  = name;
				response += ":";
				response += prize;
				response += ":";
				response += p->name;
				response += "\n";
				ofstream prizefile("prizes.txt", ios::app);
				prizefile << response;
				prizefile.close();
				sendPrivate(p,"Recieved.");
			}
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if (c->check("prize"))
			{
				if(isNumeric(c->final))
				{
					ForcePrize = atoi(c->final);
					sendPrivate(p,"Prizing");
					countdown[0] = 11;
				}
			}

			else if (c->check("listprize"))
			{
				if(c->final)
				{
					char line[100];
					ifstream prizefile("prizes.txt");
					if (!prizefile) 
					{
						tell(makeEcho("Listprize attempt failed.  \"prizes.txt\" not found."));
						return;
					}
					while(prizefile.getline(line,100)) 
					{
						staffer = line;
						player  = staffer.split(':');
						prize   = staffer.split(':');
						String pname = c->final;
						if(player == pname)
						{
							sendPrivate(p,String(player)+" has "+String(prize)+" available, given by "+String(staffer)+".");
						}
					}
					prizefile.close();
				}
			}
			else if (c->check("allowclaim"))
			{
				String final = c->final;
				if(final == "false")
					AllowPrizeMe = false;
				if(final == "true")
					AllowPrizeMe = true;
				else
				{
					sendPrivate(p,"Invalid paramater.  Only \"true\" or \"false\" allowed.  Assumed \"true\"");
					AllowPrizeMe = true;
				}

			}
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
			if (c->check("about"))
			{
				sendPrivate(p, "Prize bot version .2 by Explody Thingy (explody@sscentral.com)");
			}
			if (c->check("absoluteversion"))
			{
				sendPrivate(p, ABSOLUTE_VERSION);
			}
			else if (c->check("prizeme"))
			{
				if(!AllowPrizeMe)
				{
					sendPrivate(p,"Disabled in this arena");
					break;
				}
				the_whole_file_string = "";
				bool foundit = false;
				char line[100];
				ifstream prizefile("prizes.txt");
				if (!prizefile) 
				{
					tell(makeEcho("Prizeing attempt failed.  \"prizes.txt\" not found."));
					return;
				}
				while(prizefile.getline(line,100)) 
				{
					if(!foundit)
					{
						staffer = line;
						player  = staffer.split(':');
						prize   = staffer.split(':');
						String pname = p->name;
						if(player == pname)
						{
							foundit = true;
						}
						else
						{	
							the_whole_file_string += line;
							the_whole_file_string += "\n";
						}
					}
					else
					{
						the_whole_file_string += line;
						the_whole_file_string += "\n";
					}
				}
				prizefile.close();
				if(foundit)
				{
					Prize(p);
					foundit = false;
				}
			}
			else if (c->check("listprize"))
			{
				char line[100];
				ifstream prizefile("prizes.txt");
				if (!prizefile) 
				{
					tell(makeEcho("Listprize attempt failed.  \"prizes.txt\" not found."));
					return;
				}
				while(prizefile.getline(line,100)) 
				{
					staffer = line;
					player  = staffer.split(':');
					prize   = staffer.split(':');
					String pname = p->name;
					if(player == pname)
					{
						sendPrivate(p, "You have " +String(prize) +" available, given by " +String(staffer) +".");
					}
				}
				prizefile.close();
			}
		}
	}
}

void botInfo::gotRemoteHelp(char *p, Command *c, Operator_Level l)
{
	// List commands

	if (!*c->final)
	{
		switch (l)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotRemote(char *p, Command *c, Operator_Level l)
{
	if (!c) return;

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}
